//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		loader.c
// ߲:		IAR Atmel AVR C/EC++߲
// o͗:
// Ǝ:	E, VU
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		ݒ蕔''create'°قpĐ'update'°قɂđ
//				)Íް ڰтMAǂڰтŋLq
//				߂s܂B
//
//				葽̏ɂĂ͉pLqQƂĂB
//
// ̑:
//=============================================================================

#include <inavr.h>
#include <ioavr.h>
#include "spm.h"
#include "aes.h"
#include "loader.h"
#include "bootldr.h"
#include "bus.h"
#include "crc.h"

//=============================================================================
// ُ필

#define ERROR_OK		0x11
#define ERROR_CRC		0x22

//=============================================================================
// ڰь`

#define TYPE_EOF		0
#define TYPE_ERASE		1
#define TYPE_PREPARE	2
#define TYPE_DATA		3
#define TYPE_PROGRAM	4
#define TYPE_EEPROM		5
#define TYPE_LOCKBITS	6
#define TYPE_RESET		7

//=============================================================================
// ÍAp޸(INITIALVECTOR_x'create'°قɂĐ
// 'bootldr.h'Œ`܂)B

#if KEY_COUNT > 0
BOOTFLASH unsigned char initialVector[16] =
{
	(unsigned char)(INITIALVECTOR_3 >> 24),
	(unsigned char)(INITIALVECTOR_3 >> 16),
	(unsigned char)(INITIALVECTOR_3 >> 8),
	(unsigned char)(INITIALVECTOR_3 >> 0),
	(unsigned char)(INITIALVECTOR_2 >> 24),
	(unsigned char)(INITIALVECTOR_2 >> 16),
	(unsigned char)(INITIALVECTOR_2 >> 8),
	(unsigned char)(INITIALVECTOR_2 >> 0),
	(unsigned char)(INITIALVECTOR_1 >> 24),
	(unsigned char)(INITIALVECTOR_1 >> 16),
	(unsigned char)(INITIALVECTOR_1 >> 8),
	(unsigned char)(INITIALVECTOR_1 >> 0),
	(unsigned char)(INITIALVECTOR_0 >> 24),
	(unsigned char)(INITIALVECTOR_0 >> 16),
	(unsigned char)(INITIALVECTOR_0 >> 8),
	(unsigned char)(INITIALVECTOR_0 >> 0)
};
#endif // KEY_COUNT > 0

//=============================================================================
// ݒ蕔ٰ݁Bڰт̌`ɂĂ̂葽̏ɊւĂ͉pLqQƂ
// ĂB

union {
	struct {
		unsigned char m_rxBuffer[BUFFER_SIZE];	// MɏՕ
		unsigned char m_pageBuffer[PAGE_SIZE];	// ߰ނׯ ؂ɏOɂőgݗĂ܂B
	} part1;

#if KEY_COUNT > 0
	struct {
		unsigned char m_tempbuf[256];			// aesInitpꎞɏՕ
	} part2;
#endif
} sharedbufs;

#define rxBuffer   sharedbufs.part1.m_rxBuffer
#define pageBuffer sharedbufs.part1.m_pageBuffer
#if KEY_COUNT > 0
	#define tempbuf    sharedbufs.part2.m_tempbuf
#endif

__C_task void loader(void)
{
	#if KEY_COUNT > 0
		unsigned char chainCipherBlock[16];		// ÍApɏՕ

		// ޸ÍA擪ɕ
		{
			unsigned char *p = chainCipherBlock;
			unsigned char BOOTFLASH *q = initialVector;
			unsigned char n = 16;

			do
			{
				*p++ = *q++;
			}
			while (--n);
		}
		
		aesInit( tempbuf );						// AESZ@
	#endif

	// ڰїp޽
	busPrepare();

	// ޯ ϊJn(lт܂AIARɒʒmĂ޸ނ(2.28Ał)iom8.hɂ܂)B
#if 1
	#if !defined(WDTCR) && !defined(__IOM8_H)
		#define WDTCR WDTCSR
	#endif

	#if defined(__IOM16_H) || defined(__IOM32_H)
		WDTCR = (7 << WDP0) | (1 << WDE);
	#else
		#if defined(__IOM8_H)
			WDTCR = (1 << WDTOE) | (1 << WDE);
		#else
			WDTCR = (1 << WDCE) | (1 << WDE);
		#endif
		WDTCR = (7 << WDP0) | (1 << WDE);
	#endif
#endif

	// ivJԂ(̌JԂRESETL^悪MꂽɳޯނɂĔj܂B)
	for (;;)
	{
		frameindex_t frameSize;
		unsigned int crc;

		// ڰїeʎ擾
		frameSize =	((frameindex_t)busReceiveByte() << 8) |	busReceiveByte();

		// ʐM̪ް ڰтMĂCRCvZ
		{
			unsigned char *p = rxBuffer;
			frameindex_t n = frameSize;

			crc = 0;
			do
			{
				unsigned char ch;

				ch = busReceiveByte();

				*p++ = ch;
				crc = CRC(crc, ch);
				
				__watchdog_reset();
			}
			while (--n);

			busBusy();
		}

		// CRCOKȂ
		if (crc == 0x0000)
		{
			unsigned char *p = rxBuffer;

			// 16޲ĉǁACRC޲Ă͖܂B
			#if KEY_COUNT > 0
			{
				unsigned char *p = rxBuffer;

				frameSize -= 2;
				do
				{
					__watchdog_reset();
					aesDecrypt(p, chainCipherBlock);
					p += 16;
				}
				while (frameSize -= 16);
			}
			#endif // KEY_COUNT > 0

			// [
			if ((*p++ == (unsigned char)(SIGNATURE >> 24)) &&
				(*p++ == (unsigned char)(SIGNATURE >> 16)) &&
				(*p++ == (unsigned char)(SIGNATURE >>  8)) &&
				(*p++ == (unsigned char)(SIGNATURE >>  0)))
			{
				unsigned char APPFLASH *address;
				unsigned char bits;
				frameindex_t size;
				unsigned char type;

				// 'ڰяI'M܂ڰщ͑s
				while ((type = *p++) != TYPE_EOF)
				{
					__watchdog_reset();

					// (TYPE_LOCKBITSŎgp){ޯĎM
					bits = *p++;

					// ]ڽ(:'bits''address'͏d)
#pragma diag_suppress=Pe1053 // long^flash ptrւ̕ϊɊւx
					address =
						(unsigned char APPFLASH *)((unsigned long)bits << 16);
					address = (unsigned char APPFLASH *)
						((unsigned long)address | ((unsigned long)*p++ << 8));
					address = (unsigned char APPFLASH *)
						((unsigned long)address | *p++);
#pragma diag_default=Pe1053 // ɖ߂

					size = ((unsigned int)*p++ << 8);
					size |= *p++;

					switch (type)
					{
						// ߰ޏ
						case TYPE_ERASE:
							spmErasePage(address);
							// (ʂ蔲!)

						// ߰ފɏՕ߰ޓe𕡎ʂ邱Ƃɂēް̑傫ȉ
						case TYPE_PREPARE:
						{
							unsigned char *q = pageBuffer;
							unsigned char APPFLASH *r = address;

							do
							{
								*q++ = *r++;
							}
							while (--size);
							break;
						}

						// ް̑傫ȉ߰ފɏՕɏ
						case TYPE_DATA:
						{
							unsigned char *r =
								&pageBuffer[(unsigned long)(address) & 0xffff];

							do
							{
								*r++ = *p++;
							}
							while (--size);
							break;
						}

						// ߰ފɏՕׯ ߰ނɏ
						case TYPE_PROGRAM:
						{
							unsigned int *q = (unsigned int *)pageBuffer;
							unsigned char APPFLASH *r = address;

							do
							{
								__watchdog_reset();
								spmWriteWord(r, *q++);
								r += 2;
							}
							while (--size);

							spmErasePage(address);
							spmProgramPage(address);
							break;
						}

						// ް̑傫ȉEEPROMɏ
						case TYPE_EEPROM:
							do
							{
								__watchdog_reset();
								spmEEWriteByte(
									(unsigned long)address++ & 0xffff, *p++
								);
							}
							while (--size);
							break;

						// {ޯď
						case TYPE_LOCKBITS:
							spmWriteLockBits(bits);
							break;

						// ؾ(ޯ ςo߂܂)!
						case TYPE_RESET:
							busReplyByte(ERROR_OK);
							for(;;);

						// smڰ(1޲Ē)
						default:
							p -= 5;
							break;
					}
				}
			}

			busReplyByte(ERROR_OK);
		}
		else
			busReplyByte(ERROR_CRC);
	}
}
