//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		OutputWriter.h
// ߲:		WC++߲
// o͗:
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:		21-Feb-2005 (AESp)     RAA (ATMELٳ)
//
// xҰ:		avr@atmel.com
//
// :		OutputWriter͈ȉ3̧ق𐶐܂B
//				- ް۰ނ`Ԑݒ肷'bootldr'pͯ ̧
//				- Mް𐳂ǂ邽߂'bootldr'p̧̌
//				- ŖړIΏAVRɑ邱ƂłDESÍ̧
//
// ̑:
//=============================================================================

#ifndef OUTPUTWRITER_H
#define OUTPUTWRITER_H

#include <stdio.h>
#include "DataBuffer.h"
#include "AES.h"
#include "MemoryMap.h"

typedef enum {
	TYPE_EOF = 0,
	TYPE_ERASE = 1, 
	TYPE_PREPARE = 2,
	TYPE_DATA = 3,
	TYPE_PROGRAM = 4,
	TYPE_EEPROM = 5,
	TYPE_LOCKBITS = 6,
	TYPE_RESET = 7,
	TYPE_NONSENSE_FIRST = 8,
	TYPE_NONSENSE_LAST = 255
} RecordType;

class OutputWriter
{
public:
	OutputWriter(MemoryMap *flash, MemoryMap *eeprom, 
		unsigned int pageSize, DataBuffer *key,
		DataBuffer& initialVector, DataBuffer& signature,
		bool updateLockBits, unsigned char lockBits, unsigned int memSize,
		int keyCount, bool createFlashCRC, bool eraseFlash, bool nonsenseRecords
	);
	virtual ~OutputWriter();

	void writeKeyFile(char *filename);
	void writeHeaderFile(char *filename);

	void writeOutputFile(char *filename);

private:
	void writeFrame();
	void insertRecord(DataBuffer& record);

	void writeFlash();
	void writeEEPROM();
	void writeLockBits();
	void writeResetSW();
	unsigned short crc(unsigned char ch, unsigned short oldCRC);

	DataBuffer& buildRecord(RecordType type, int addr, int size,
							const DataBuffer& buffer);

	DataBuffer& buildRecordErase(unsigned int pageAddress);
	DataBuffer& buildRecordPrepare(unsigned int pageAddress);
	DataBuffer& buildRecordWrite(unsigned int pageAddress, unsigned int index, 
								 size_t length);
	DataBuffer& buildRecordProgram(unsigned int pageAddress);
	DataBuffer& buildRecordEEPROM(unsigned int address, size_t length);
	DataBuffer& buildRecordLockBitsWrite();
	DataBuffer& buildRecordResetSW();

	Aes *aesM;

	unsigned int frameMaxSizeM;		// 1ڰт̍őe
	unsigned int recordMaxSizeM;	// 1ڰѓɖvL^̍őe
	unsigned int bufferSizeM;		// 1̊Sȑ傫ڰтM\͂ɏՕ̗e

	unsigned int pageSizeM;			// ޲ĂłAVR߰ޗe
	unsigned int memSizeM;			// ޲ĂłAVR̉p̈e

	MemoryMap *flashM;				// p̈؊蓖
	MemoryMap *eepromM;				// EEPROM؊蓖

	DataBuffer initialVectorM;		// ÍA(CBC)p޸
	DataBuffer signatureM;			// Fڰюʂ̂߂ɊeڰтŎgp鎯[
	DataBuffer frameBufferM;		// ڰтgݗĂɏՕ

	int keyCountM;					// AES
	DataBuffer *keyM;				// ܂ޕ\

	FILE *outputFileM;				// o̧ٗpFILE

	bool updateLockBitsM;			// {ޯčXVL?
	unsigned char lockBitsM;		// {ޯĂ̐V

	bool createFlashCRCM;			// p̈pCRCvZ̗L?
	bool eraseFlashM;				// OɖړIΏAVRŊe߰ޏ̗L?
	float nonsenseProbabilityM;		// ̖{̋L^OɕsmL^쐬m
};

#endif // OUTPUTWRITER_H
